## confget 1.02

=== Makefile ===
# Copyright (c) 2008, 2009  Peter Pentchev
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Ringlet: Makefile 3158 2009-03-20 13:17:48Z roam $

# You MUST define either -DHAVE_GETLINE or -DHAVE_FGETLN in CFLAGS_CONF!
#CFLAGS_CONF=	-DHAVE_GETLINE

LOCALBASE?=	/usr/local
PREFIX?=	${LOCALBASE}
BINDIR?=	${PREFIX}/bin
MANDIR?=	${PREFIX}/man/man
EXAMPLESDIR?=	${PREFIX}/share/examples/${PROG}

PCRE_CFLAGS?=	-DHAVE_PCRE -I${LOCALBASE}/include
PCRE_LIBS?=	-L${LOCALBASE}/lib -lpcre

CC?=		gcc
CFLAGS?=		-g -pipe
CFLAGS+=	-Wall -W -Werror ${CFLAGS_CONF} ${PCRE_CFLAGS}
LDFLAGS?=
LFLAGS?=	${LDFLAGS}
LIBS?=

RM=		rm -f
MKDIR?=		mkdir -p
SETENV?=	env

PROG=		confget
OBJS=		confget.o confget_common.o confget_http_get.o confget_ini.o
SRCS=		confget.c confget_common.c confget_http_get.c confget_ini.c
DEPENDFILE=	.depend

EXAMPLES=	t/t1.ini t/t2.ini

MAN1=		confget.1
MAN1GZ=		${MAN1}.gz

BINOWN?=	root
BINGRP?=	wheel
BINMODE?=	555

MANOWN?=	${BINOWN}
MANGRP?=	${BINGRP}
MANMODE?=	644

SHAREOWN?=	${BINOWN}
SHAREGRP?=	${BINGRP}
SHAREMODE?=	644

# development/debugging flags, you may safely ignore them
BDECFLAGS=	-W -Wall -ansi -pedantic -Wbad-function-cast -Wcast-align \
		-Wcast-qual -Wchar-subscripts -Winline \
		-Wmissing-prototypes -Wnested-externs -Wpointer-arith \
		-Wredundant-decls -Wshadow -Wstrict-prototypes -Wwrite-strings
#CFLAGS+=	${BDECFLAGS}
#CFLAGS+=	-ggdb -g3

all:		${PROG} ${MAN1GZ}

clean:
		${RM} ${PROG} ${OBJS} ${MAN1GZ}

${PROG}:	${OBJS}
		${CC} ${LFLAGS} -o ${PROG} ${OBJS} ${PCRE_LIBS}

.c.o:
		${CC} ${CFLAGS} -c $<

${MAN1GZ}:	${MAN1}
		gzip -c9 ${MAN1} > ${MAN1GZ}.tmp
		mv ${MAN1GZ}.tmp ${MAN1GZ}

install:	all install-bin install-man install-examples

install-bin:
		-${MKDIR} ${DESTDIR}${BINDIR}
		install -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} ${PROG} ${DESTDIR}${BINDIR}/

install-man:
		-${MKDIR} ${DESTDIR}${MANDIR}1
		install -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} ${MAN1GZ} ${DESTDIR}${MANDIR}1/

install-examples:
		-${MKDIR} ${DESTDIR}${EXAMPLESDIR}
		install -c -o ${SHAREOWN} -g ${SHAREGRP} -m ${SHAREMODE} ${EXAMPLES} ${DESTDIR}${EXAMPLESDIR}/

depend:
		${SETENV} CFLAGS="${CFLAGS}" DEPENDFILE="${DEPENDFILE}" \
		sh makedep.sh ${SRCS}
		
test:		all
		prove t

.PHONY:		all clean depend install test

include ${DEPENDFILE}

=== debian/changelog ===
confget (1.02-3~bpo50+1) lenny-backports; urgency=low

  * Rebuild for lenny-backports.
  * Add versioned build-dependency on groff-base with an option
    to get groff back.
  * Drop using dpkg-buildflags since we target lenny.

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 05 Sep 2011 12:55:24 +0200

confget (1.02-3) unstable; urgency=low

  * Simplify the rules file by removing the useless diffsrc target;
    it was intended for my own use, but its time has long passed.
  * Simplify the rules file even more by using debhelper override rules.
  * Bump Standards-Version to 3.8.4 with no changes.
  * Switch to the 3.0 (quilt) source format - we don't have any patches,
    but I still like its debian.tar.gz distribution mode.
  * Bump the copyright years on the Debian packaging.
  * Drop the groff dependency - europs.tmac was moved into
    groff-base-1.20.1-6 and our test suite works again.
  * Update the copyright file to DEP 5 rev. 135:
    - declare the public domain status in the Copyright clause, too
    - use BSD instead of BSD-2
  * Use dpkg-buildflags from dpkg-dev 1.15.7 to obtain CFLAGS, CPPFLAGS,
    and LDFLAGS instead of depending on dpkg-buildpackage to provide them.
  * Shorten the Vcs-Browser URL.
  * Bump Standards-Version to 3.9.0 with no changes.

 -- Peter Pentchev <roam@ringlet.net>  Mon, 28 Jun 2010 17:38:07 +0300

confget (1.02-2) unstable; urgency=low

  * Only enable the hardening wrapper conditionally.
  * Bump Standards-Version to 3.8.2 with no changes.
  * Remove the useless "configure" target from the rules file.
  * In the copyright file, break out the license in a separate section and
    declare compatibility with the current revision of DEP 5.
  * Add groff as a build dependency for the test suite; groff-base seems
    to not be enough any longer.

 -- Peter Pentchev <roam@ringlet.net>  Tue, 11 Aug 2009 15:42:47 +0300

confget (1.02-1) unstable; urgency=low

  * New upstream version.
  * Specify the examples directory location at install time.
  * Update the copyright file.

 -- Peter Pentchev <roam@ringlet.net>  Sat, 21 Mar 2009 19:28:39 +0200

confget (1.01-1) unstable; urgency=low

  * Initial release. Closes: #502543.

 -- Peter Pentchev <roam@ringlet.net>  Tue, 17 Mar 2009 18:10:35 +0200

=== debian/control ===
Source: confget
Section: text
Priority: optional
Maintainer: Peter Pentchev <roam@ringlet.net>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.0.50~), groff-base (>= 1.20.1-6~) | groff, hardening-wrapper, libpcre3-dev
Standards-Version: 3.9.0
Homepage: http://devel.ringlet.net/textproc/confget/
Vcs-Svn: http://svn.ringlet.net/svn/ringlet/textproc/confget/trunk/confget-pkg/debian/
Vcs-Browser: http://svn.ringlet.net/v/ringlet/textproc/confget/trunk/confget-pkg/debian/

Package: confget
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: read variables from INI-style configuration files
 The confget utility examines a INI-style configuration file and retrieves
 the value of the specified variables from the specified section.
 Its intended use is to let shell scripts use the same INI-style
 configuration files as other programs, to avoid duplication of data.
 .
 The confget utility may retrieve the values of one or more variables,
 list all the variables in a specified section, list only those whose names
 or values match a specified pattern (shell glob or regular expression), or
 check if a variable is present in the file at all.  It has a "shell-quoting"
 output mode that quotes the variable values in a way suitable for passing
 them directly to a Bourne-style shell.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Debian build rules for confget, the configuration variable extractor

CFLAGS+=	-pipe -Wall -W -ansi -pedantic -Wbad-function-cast \
		-Wcast-align -Wcast-qual -Wchar-subscripts -Winline \
		-Wmissing-prototypes -Wnested-externs -Wpointer-arith \
		-Wredundant-decls -Wshadow -Wstrict-prototypes -Wwrite-strings
ifneq (,$(filter werror,$(DEB_BUILD_OPTIONS)))
	CFLAGS+=	-Werror
endif
ifeq (,$(filter hardening,$(DEB_BUILD_OPTIONS)))
export DEB_BUILD_HARDENING=0
else
export DEB_BUILD_HARDENING=1
endif

export CFLAGS CPPFLAGS LDFLAGS
export CFLAGS_CONF=-DHAVE_GETLINE
export PCRE_CFLAGS=-DHAVE_PCRE
export PCRE_LIBS=-lpcre

override_dh_auto_install:
	dh_auto_install -- DESTDIR=${CURDIR}/debian/confget PREFIX=/usr \
		MANDIR=/usr/share/man/man BINGRP=root MANGRP=root \
		EXAMPLESDIR=/usr/share/doc/confget/examples

%:
	dh $@

## confget 1.03

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2008, 2009  Peter Pentchev
+# Copyright (c) 2008, 2009, 2011  Peter Pentchev
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -22,7 +22,7 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Ringlet: Makefile 3158 2009-03-20 13:17:48Z roam $
+# $Ringlet$
 
 # You MUST define either -DHAVE_GETLINE or -DHAVE_FGETLN in CFLAGS_CONF!
 #CFLAGS_CONF=	-DHAVE_GETLINE
@@ -38,7 +38,7 @@
 
 CC?=		gcc
 CFLAGS?=		-g -pipe
-CFLAGS+=	-Wall -W -Werror ${CFLAGS_CONF} ${PCRE_CFLAGS}
+CFLAGS+=	-Wall -W ${CFLAGS_CONF} ${PCRE_CFLAGS}
 LDFLAGS?=
 LFLAGS?=	${LDFLAGS}
 LIBS?=

=== debian/changelog ===
confget (1.03-1) unstable; urgency=low

  * New upstream release:
    - allow spaces in INI file section names.  Closes: #632400
    - update the copyright years in debian/copyright
  * Bump Standards-Version to 3.9.2 with no changes.
  * Update the copyright file to the latest DEP 5 candidate format and
    fix the DEP 5 URL after the Alioth migration.
  * Add Multi-Arch: foreign to the binary package.

 -- Peter Pentchev <roam@ringlet.net>  Wed, 06 Jul 2011 19:52:10 +0300

confget (1.02-5) unstable; urgency=low

  * Update the copyright file to the latest DEP 5 candidate format and
    bump the year of my copyright notice.
  * Upload to unstable.

 -- Peter Pentchev <roam@ringlet.net>  Tue, 08 Feb 2011 17:30:54 +0200

confget (1.02-4) experimental; urgency=low

  * Switch to Git and point the Vcs-* fields to Gitorious.
  * Bump Standards-Version to 3.9.1 with no changes.
  * Switch to bzip2 compression for the Debian tarball.
  * Fix the formatting of the copyright file - Maintainer at the top,
    no Author in the file stanzas.
  * Wrap the Build-Depends line.
  * Turn on the build hardening by default.
  * Use the hardening-includes package instead of hardening-wrapper so that
    the hardening flags are visible in CFLAGS and LDFLAGS.
  * Bump the debhelper compatibility level to 8 with no changes.

 -- Peter Pentchev <roam@ringlet.net>  Fri, 24 Dec 2010 16:26:38 +0200

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,17 @@
 Priority: optional
 Maintainer: Peter Pentchev <roam@ringlet.net>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 7.0.50~), groff-base (>= 1.20.1-6~) | groff, hardening-wrapper, libpcre3-dev
-Standards-Version: 3.9.0
+Build-Depends: debhelper (>> 8), dpkg-dev (>= 1.15.7~),
+	hardening-includes, libpcre3-dev
+Standards-Version: 3.9.2
 Homepage: http://devel.ringlet.net/textproc/confget/
-Vcs-Svn: http://svn.ringlet.net/svn/ringlet/textproc/confget/trunk/confget-pkg/debian/
-Vcs-Browser: http://svn.ringlet.net/v/ringlet/textproc/confget/trunk/confget-pkg/debian/
+Vcs-Git: git://gitorious.org/confget/pkg-debian.git
+Vcs-Browser: http://gitorious.org/confget/pkg-debian
 
 Package: confget
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Multi-Arch: foreign
 Description: read variables from INI-style configuration files
  The confget utility examines a INI-style configuration file and retrieves
  the value of the specified variables from the specified section.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,10 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 # Debian build rules for confget, the configuration variable extractor
+
+CFLAGS=		$(shell dpkg-buildflags --get CFLAGS)
+CPPFLAGS=	$(shell dpkg-buildflags --get CPPFLAGS)
+LDFLAGS=	$(shell dpkg-buildflags --get LDFLAGS)
 
 CFLAGS+=	-pipe -Wall -W -ansi -pedantic -Wbad-function-cast \
 		-Wcast-align -Wcast-qual -Wchar-subscripts -Winline \
@@ -9,10 +13,11 @@
 ifneq (,$(filter werror,$(DEB_BUILD_OPTIONS)))
 	CFLAGS+=	-Werror
 endif
-ifeq (,$(filter hardening,$(DEB_BUILD_OPTIONS)))
-export DEB_BUILD_HARDENING=0
-else
-export DEB_BUILD_HARDENING=1
+
+include /usr/share/hardening-includes/hardening.make
+ifeq (,$(filter nohardening,$(DEB_BUILD_OPTIONS)))
+CFLAGS+=	$(HARDENING_CFLAGS)
+LDFLAGS+=	$(HARDENING_LDFLAGS)
 endif
 
 export CFLAGS CPPFLAGS LDFLAGS

=== debian/watch ===
version=3
http://devel.ringlet.net/textproc/confget/ confget-(.*)\.tar\.gz

## confget 1.05

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2008, 2009, 2011  Peter Pentchev
+# Copyright (c) 2008, 2009, 2011, 2012, 2013  Peter Pentchev
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -24,23 +24,23 @@
 #
 # $Ringlet$
 
-# You MUST define either -DHAVE_GETLINE or -DHAVE_FGETLN in CFLAGS_CONF!
-#CFLAGS_CONF=	-DHAVE_GETLINE
-
 LOCALBASE?=	/usr/local
 PREFIX?=	${LOCALBASE}
 BINDIR?=	${PREFIX}/bin
 MANDIR?=	${PREFIX}/man/man
 EXAMPLESDIR?=	${PREFIX}/share/examples/${PROG}
 
-PCRE_CFLAGS?=	-DHAVE_PCRE -I${LOCALBASE}/include
+LFS_CPPFLAGS?=	-D_FILE_OFFSET_BITS=64
+
+PCRE_CPPFLAGS?=	-DHAVE_PCRE -I${LOCALBASE}/include
 PCRE_LIBS?=	-L${LOCALBASE}/lib -lpcre
 
 CC?=		gcc
+CPPFLAGS?=
+CPPFLAGS+=	${LFS_CPPFLAGS} ${PCRE_CPPFLAGS}
 CFLAGS?=		-g -pipe
-CFLAGS+=	-Wall -W ${CFLAGS_CONF} ${PCRE_CFLAGS}
+CFLAGS+=	-Wall -W
 LDFLAGS?=
-LFLAGS?=	${LDFLAGS}
 LIBS?=
 
 RM=		rm -f
@@ -70,23 +70,26 @@
 SHAREMODE?=	644
 
 # development/debugging flags, you may safely ignore them
-BDECFLAGS=	-W -Wall -ansi -pedantic -Wbad-function-cast -Wcast-align \
+BDECFLAGS=	-W -Wall -std=c99 -pedantic -Wbad-function-cast -Wcast-align \
 		-Wcast-qual -Wchar-subscripts -Winline \
 		-Wmissing-prototypes -Wnested-externs -Wpointer-arith \
 		-Wredundant-decls -Wshadow -Wstrict-prototypes -Wwrite-strings
 #CFLAGS+=	${BDECFLAGS}
 #CFLAGS+=	-ggdb -g3
 
+TESTEXEC=	test-getline test-fgetln
+
 all:		${PROG} ${MAN1GZ}
 
 clean:
 		${RM} ${PROG} ${OBJS} ${MAN1GZ}
+		${RM} ${TESTEXEC} readaline.h
 
 ${PROG}:	${OBJS}
-		${CC} ${LFLAGS} -o ${PROG} ${OBJS} ${PCRE_LIBS}
+		${CC} ${LDFLAGS} -o ${PROG} ${OBJS} ${PCRE_LIBS}
 
 .c.o:
-		${CC} ${CFLAGS} -c $<
+		${CC} ${CPPFLAGS} ${CFLAGS} -c $<
 
 ${MAN1GZ}:	${MAN1}
 		gzip -c9 ${MAN1} > ${MAN1GZ}.tmp
@@ -107,12 +110,27 @@
 		install -c -o ${SHAREOWN} -g ${SHAREGRP} -m ${SHAREMODE} ${EXAMPLES} ${DESTDIR}${EXAMPLESDIR}/
 
 depend:
-		${SETENV} CFLAGS="${CFLAGS}" DEPENDFILE="${DEPENDFILE}" \
-		sh makedep.sh ${SRCS}
+		touch readaline.h
+		${SETENV} CPPFLAGS="-DCONFGET_MAKEDEP ${CPPFLAGS}" \
+		DEPENDFILE="${DEPENDFILE}" sh makedep.sh ${SRCS}
+		rm -f readaline.h
 		
 test:		all
 		prove t
 
+readaline.h:	test-getline.c Makefile
+		rm -f readaline.h
+		if ${CC} ${CPPFLAGS} ${CFLAGS} ${LDFLAGS} -o test-getline test-getline.c ${LIBS}; then \
+			echo '#define HAVE_GETLINE' > readaline.h; \
+		else if ${CC} ${CPPFLAGS} ${CFLAGS} ${LDFLAGS} -o test-fgetln test-fgetln.c ${LIBS}; then \
+			echo '#define HAVE_FGETLN' > readaline.h; \
+		else \
+			echo 'Neither getline() nor fgetln() found!' 1>&2; \
+			false; \
+		fi; fi
+
 .PHONY:		all clean depend install test
 
+ifeq ($(wildcard ${DEPENDFILE}),${DEPENDFILE})
 include ${DEPENDFILE}
+endif

=== debian/changelog ===
confget (1.05-1) unstable; urgency=medium

  * Update the copyright file:
    - convert it to the 1.0 format
    - separate lists of copyrighted files with whitespace, not commas
    - bump the year of my copyright notice
    - fix the upstream homepage location
  * Bump Standards-Version to 3.9.5 with no changes.
  * Bump the debhelper compatibility level to 9 with no changes.
  * Get the hardening options directly from debhelper:
    - remove the build dependency on hardening-includes
    - no longer include the hardening Makefile snippet into the rules file
    - explicitly enable all the hardening features; they may be disabled
      in the future if confget should fail to build anywhere
    - use DEB_CFLAGS_MAINT_APPEND to, well, append to CFLAGS
  * Enable parallel building - not that it matters a lot in this case :)
  * New upstream release:
    - honors CPPFLAGS now, so the hardening flags may be passed as-is
    - autodetects getline(3) support, so no need for CFLAGS_CONF
    - renames PCRE_CFLAGS to PCRE_CPPFLAGS, so follow suit
    - update the copyright years in the copyright file
    - follow upstream and switch from -ansi to -std=c99
  * Remove the obsolete DM-Upload-Allowed field.
  * Drop the source compression options; dpkg-dev's defaults are good enough.
  * Update the watch file after the devel.ringlet.net website change.
  * Let uscan verify upstream's signature against my own key.

 -- Peter Pentchev <roam@ringlet.net>  Sat, 23 Aug 2014 12:07:22 +0300

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,8 @@
 Section: text
 Priority: optional
 Maintainer: Peter Pentchev <roam@ringlet.net>
-DM-Upload-Allowed: yes
-Build-Depends: debhelper (>> 8), dpkg-dev (>= 1.15.7~),
-	hardening-includes, libpcre3-dev
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>> 9), libpcre3-dev
+Standards-Version: 3.9.5
 Homepage: http://devel.ringlet.net/textproc/confget/
 Vcs-Git: git://gitorious.org/confget/pkg-debian.git
 Vcs-Browser: http://gitorious.org/confget/pkg-debian

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Debian build rules for confget, the configuration variable extractor

# Aim for the top, adapt if anything should break on the buildds.
DEB_BUILD_MAINT_OPTIONS=	hardening=+all
export DEB_BUILD_MAINT_OPTIONS

DEB_CFLAGS_MAINT_APPEND=	-pipe -Wall -W -std=c99 -pedantic -Wbad-function-cast \
		-Wcast-align -Wcast-qual -Wchar-subscripts -Winline \
		-Wmissing-prototypes -Wnested-externs -Wpointer-arith \
		-Wredundant-decls -Wshadow -Wstrict-prototypes -Wwrite-strings
ifneq (,$(filter werror,$(DEB_BUILD_OPTIONS)))
	DEB_CFLAGS_MAINT_APPEND+=	-Werror
endif
export DEB_CFLAGS_MAINT_APPEND

export PCRE_CPPFLAGS=-DHAVE_PCRE
export PCRE_LIBS=-lpcre

override_dh_auto_install:
	dh_auto_install -- DESTDIR=${CURDIR}/debian/confget PREFIX=/usr \
		MANDIR=/usr/share/man/man BINGRP=root MANGRP=root \
		EXAMPLESDIR=/usr/share/doc/confget/examples

%:
	dh $@ --parallel

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
http://devel.ringlet.net/textproc/confget/ http://devel.ringlet.net/(?:files/)?textproc/confget/confget-(.*)\.tar\.gz

## confget 2.0.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2008, 2009, 2011, 2012, 2013  Peter Pentchev
+# Copyright (c) 2008, 2009, 2011, 2012, 2013, 2016  Peter Pentchev
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -21,8 +21,6 @@
 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
-#
-# $Ringlet$
 
 LOCALBASE?=	/usr/local
 PREFIX?=	${LOCALBASE}
@@ -30,17 +28,24 @@
 MANDIR?=	${PREFIX}/man/man
 EXAMPLESDIR?=	${PREFIX}/share/examples/${PROG}
 
+STD_CPPFLAGS?=	-D_POSIX_C_SOURCE=200809L -D_XOPEN_SOURCE=700
+
 LFS_CPPFLAGS?=	-D_FILE_OFFSET_BITS=64
+LFS_LDFLAGS?=
 
 PCRE_CPPFLAGS?=	-DHAVE_PCRE -I${LOCALBASE}/include
 PCRE_LIBS?=	-L${LOCALBASE}/lib -lpcre
 
+STD_CFLAGS?=	-std=c99
+WARN_CFLAGS?=	-Wall -W
+
 CC?=		gcc
 CPPFLAGS?=
-CPPFLAGS+=	${LFS_CPPFLAGS} ${PCRE_CPPFLAGS}
+CPPFLAGS+=	${STD_CPPFLAGS} ${LFS_CPPFLAGS} ${PCRE_CPPFLAGS}
 CFLAGS?=		-g -pipe
-CFLAGS+=	-Wall -W
+CFLAGS+=	${STD_CFLAGS} ${WARN_CFLAGS}
 LDFLAGS?=
+LDFLAGS+=	${LFS_LDFLAGS}
 LIBS?=
 
 RM=		rm -f
@@ -51,8 +56,6 @@
 OBJS=		confget.o confget_common.o confget_http_get.o confget_ini.o
 SRCS=		confget.c confget_common.c confget_http_get.c confget_ini.c
 DEPENDFILE=	.depend
-
-EXAMPLES=	t/t1.ini t/t2.ini
 
 MAN1=		confget.1
 MAN1GZ=		${MAN1}.gz
@@ -106,8 +109,9 @@
 		install -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} ${MAN1GZ} ${DESTDIR}${MANDIR}1/
 
 install-examples:
-		-${MKDIR} ${DESTDIR}${EXAMPLESDIR}
-		install -c -o ${SHAREOWN} -g ${SHAREGRP} -m ${SHAREMODE} ${EXAMPLES} ${DESTDIR}${EXAMPLESDIR}/
+		-${MKDIR} ${DESTDIR}${EXAMPLESDIR}/tests
+		install -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} t/*.t ${DESTDIR}${EXAMPLESDIR}/tests/
+		install -c -o ${SHAREOWN} -g ${SHAREGRP} -m ${SHAREMODE} t/*.ini ${DESTDIR}${EXAMPLESDIR}/tests/
 
 depend:
 		touch readaline.h

=== debian/changelog ===
confget (2.0.0-1) unstable; urgency=medium

  * Use export-minimal for upstream's PGP public key.
  * Use "BSD-2-clause" as the short license name in the copyright file.
  * Point Vcs-Git and Vcs-Browser to the GitLab repository after
    the migration from Gitorious and change both to HTTPS URLs.
  * Declare compliance with Debian Policy 3.9.8 with no changes.
  * Add an upstream metadata file.
  * Bump the year on my debian/* copyright notice.
  * Bump the debhelper compatibility level to 10:
    - bump the version of the debhelper B-D to 9.20160403~
    - drop the --parallel option from the dh invocation (enabled by default)
    - override the "experimental debhelper version" Lintian warning
  * New upstream release:
    - fix a FTBFS with new versions of glibc by replacing the _GNU_SOURCE and
      _BSD_SOURCE feature macros with _POSIX_C_SOURCE and _XOPEN_SOURCE
    - install all the tests as examples, not just the *.ini files used by them
    - teach the manpage test about compressed manual pages so that it may be
      run on a system where confget has been installed, e.g. via autopkgtest
    - allow passing linker flags for Large File Support, too
  * Update the upstream copyright years in the copyright file.
  * Add an autopkgtest suite running the installed tests.
  * Look for a *.tar.bz2 tarball in the watch file and bump the version to 4.
  * Fold the upstream source into a single Files section in the copyright file.

 -- Peter Pentchev <roam@ringlet.net>  Mon, 11 Apr 2016 12:47:31 +0300

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: text
 Priority: optional
 Maintainer: Peter Pentchev <roam@ringlet.net>
-Build-Depends: debhelper (>> 9), libpcre3-dev
-Standards-Version: 3.9.5
+Build-Depends: debhelper (>> 9.20160403~), libpcre3-dev
+Standards-Version: 3.9.8
 Homepage: http://devel.ringlet.net/textproc/confget/
-Vcs-Git: git://gitorious.org/confget/pkg-debian.git
-Vcs-Browser: http://gitorious.org/confget/pkg-debian
+Vcs-Git: https://gitlab.com/confget/confget.git -b debian
+Vcs-Browser: https://gitlab.com/confget/confget/tree/debian
+Testsuite: autopkgtest
 
 Package: confget
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -18,10 +18,15 @@
 export PCRE_CPPFLAGS=-DHAVE_PCRE
 export PCRE_LIBS=-lpcre
 
+# Large File Support
+LFS_CPPFLAGS:=	$(shell getconf LFS_CFLAGS 2>/dev/null || echo "-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64")
+LFS_LDFLAGS:=	$(shell getconf LFS_LDFLAGS 2>/dev/null || true)
+export LFS_CPPFLAGS LFS_LDFLAGS
+
 override_dh_auto_install:
 	dh_auto_install -- DESTDIR=${CURDIR}/debian/confget PREFIX=/usr \
 		MANDIR=/usr/share/man/man BINGRP=root MANGRP=root \
 		EXAMPLESDIR=/usr/share/doc/confget/examples
 
 %:
-	dh $@ --parallel
+	dh $@

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
http://devel.ringlet.net/textproc/confget/ http://devel.ringlet.net/(?:files/)?textproc/confget/confget-(.*)\.tar\.bz2

## confget 2.1.0

=== debian/changelog ===
confget (2.1.0-1) unstable; urgency=medium

  * Declare compliance with Debian Policy 4.1.1 with no changes.
  * Let dpkg-buildflags take care of the LFS compiler and linker flags.
  * New upstream version; update the copyright years.
  * Add "Rules-Requires-Root: no" to the source control stanza and
    override the upstream Makefile's install(1) invocations.

 -- Peter Pentchev <roam@ringlet.net>  Sat, 11 Nov 2017 23:21:21 +0200

confget (2.0.0-3) unstable; urgency=medium

  * Update the package for compliance with Debian Policy 4.1.0:
    - do not install the example files and the manual page if "nodoc" is
      specified in DEB_BUILD_OPTIONS or the "nodoc" build profile is active
    - use the source t/ directory in the autopkgtest suite since
      /usr/share/doc/confget/examples/tests/ will not exist with "nodoc"
    - drop the implied "Testsuite: autopkgtest" source control header
  * Bump the debhelper compatibility level to 11 and the build dependency
    to 10.8~.

 -- Peter Pentchev <roam@ringlet.net>  Mon, 25 Sep 2017 12:24:14 +0300

confget (2.0.0-2) unstable; urgency=medium

  * Depend on debhelper 10 now that it is in unstable, testing, and
    jessie-backports.  Drop the Lintian override about the version.
  * Switch to the HTTPS scheme for various Debian and upstream URLs.
  * Use the v4 substitution variables in the watch file.

 -- Peter Pentchev <roam@ringlet.net>  Thu, 17 Nov 2016 13:53:02 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: text
 Priority: optional
 Maintainer: Peter Pentchev <roam@ringlet.net>
-Build-Depends: debhelper (>> 9.20160403~), libpcre3-dev
-Standards-Version: 3.9.8
-Homepage: http://devel.ringlet.net/textproc/confget/
+Build-Depends: debhelper (>> 10.8~), libpcre3-dev
+Standards-Version: 4.1.1
+Homepage: https://devel.ringlet.net/textproc/confget/
 Vcs-Git: https://gitlab.com/confget/confget.git -b debian
 Vcs-Browser: https://gitlab.com/confget/confget/tree/debian
-Testsuite: autopkgtest
+Rules-Requires-Root: no
 
 Package: confget
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Debian build rules for confget, the configuration variable extractor

# Aim for the top, adapt if anything should break on the buildds.
DEB_BUILD_MAINT_OPTIONS=	hardening=+all future=+lfs
export DEB_BUILD_MAINT_OPTIONS

DEB_CFLAGS_MAINT_APPEND=	-pipe -Wall -W -std=c99 -pedantic -Wbad-function-cast \
		-Wcast-align -Wcast-qual -Wchar-subscripts -Winline \
		-Wmissing-prototypes -Wnested-externs -Wpointer-arith \
		-Wredundant-decls -Wshadow -Wstrict-prototypes -Wwrite-strings
ifneq (,$(filter werror,$(DEB_BUILD_OPTIONS)))
	DEB_CFLAGS_MAINT_APPEND+=	-Werror
endif
export DEB_CFLAGS_MAINT_APPEND

export PCRE_CPPFLAGS=-DHAVE_PCRE
export PCRE_LIBS=-lpcre

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
DEB_NODOC=0
else
DEB_NODOC=1
endif

override_dh_auto_build:
	dh_auto_build -- LFS_CPPFLAGS= LFS_LDFLAGS=

override_dh_auto_install:
ifeq (${DEB_NODOC},1)
	mv -f Makefile Makefile.bak
	sed -e 's/^install:.*/install: all install-bin/' Makefile.bak > Makefile
endif
	dh_auto_install -- DESTDIR=${CURDIR}/debian/confget PREFIX=/usr \
		MANDIR=/usr/share/man/man BINGRP=root MANGRP=root \
		EXAMPLESDIR=/usr/share/doc/confget/examples \
		INSTALL_PROGRAM='install -m 755' \
		INSTALL_SCRIPT='install -m 755' INSTALL_DATA='install -m 644'
ifeq (${DEB_NODOC},1)
	mv -f Makefile.bak Makefile
endif

%:
	dh $@

=== debian/tests/control ===
Test-Command: if [ -d /usr/share/doc/confget/examples ]; then export MANPAGE='/usr/share/man/man1/confget.1.gz' TESTDIR='/usr/share/doc/confget/examples/tests'; else export TESTDIR='t'; fi; env CONFGET='/usr/bin/confget' prove -v "$TESTDIR"
Depends: @, perl, groff-base

## confget 2.1.1

=== debian/changelog ===
confget (2.1.1-1) unstable; urgency=medium

  * Build-depend on debhelper 11 and use the B-D: debhelper-compat (= 11)
    mechanism.
  * Bump the year on my debian/* copyright notice.
  * Use my Debian e-mail address.
  * Bring up to compliance with Debian Policy 4.2.1: install the upstream
    release notes (CHANGES) as NEWS and not changelog.
  * Add trivial autopkgtests running adequate and feature-check.
  * Minimize the upstream signing key, only keep the roam@ringlet.net UID.
  * New upstream version.

 -- Peter Pentchev <roam@debian.org>  Tue, 27 Nov 2018 11:12:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: confget
 Section: text
 Priority: optional
-Maintainer: Peter Pentchev <roam@ringlet.net>
-Build-Depends: debhelper (>> 10.8~), libpcre3-dev
-Standards-Version: 4.1.1
+Maintainer: Peter Pentchev <roam@debian.org>
+Build-Depends: debhelper-compat (= 11), libpcre3-dev
+Standards-Version: 4.2.1
 Homepage: https://devel.ringlet.net/textproc/confget/
 Vcs-Git: https://gitlab.com/confget/confget.git -b debian
 Vcs-Browser: https://gitlab.com/confget/confget/tree/debian

=== debian/rules ===
--- 
+++ 
@@ -41,5 +41,9 @@
 	mv -f Makefile.bak Makefile
 endif
 
+override_dh_installchangelogs:
+	dh_installchangelogs -X CHANGES
+	install -m 644 CHANGES debian/confget/usr/share/doc/confget/NEWS
+
 %:
 	dh $@

=== debian/tests/control ===
Test-Command: if [ -d /usr/share/doc/confget/examples ]; then export MANPAGE='/usr/share/man/man1/confget.1.gz' TESTDIR='/usr/share/doc/confget/examples/tests'; else export TESTDIR='t'; fi; env CONFGET='/usr/bin/confget' prove -v "$TESTDIR"
Depends: @, perl, groff-base

Test-Command: adequate confget
Depends: @, adequate

Test-Command: feature-check -O -qfeatures -P '' confget BASE
Depends: @, feature-check

## confget 2.2.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2008, 2009, 2011, 2012, 2013, 2016  Peter Pentchev
+# Copyright (c) 2008, 2009, 2011 - 2013, 2016, 2017  Peter Pentchev
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -64,13 +64,17 @@
 BINGRP?=	wheel
 BINMODE?=	555
 
-MANOWN?=	${BINOWN}
-MANGRP?=	${BINGRP}
-MANMODE?=	644
-
 SHAREOWN?=	${BINOWN}
 SHAREGRP?=	${BINGRP}
 SHAREMODE?=	644
+
+INSTALL?=	install
+COPY?=		-c
+STRIP?=		-s
+
+INSTALL_PROGRAM?=	${INSTALL} ${COPY} ${STRIP} -o ${BINOWN} -g ${BINGRP} -m ${BINMODE}
+INSTALL_SCRIPT?=	${INSTALL} ${COPY} -o ${BINOWN} -g ${BINGRP} -m ${BINMODE}
+INSTALL_DATA?=	${INSTALL} ${COPY} -o ${SHAREOWN} -g ${SHAREGRP} -m ${SHAREMODE}
 
 # development/debugging flags, you may safely ignore them
 BDECFLAGS=	-W -Wall -std=c99 -pedantic -Wbad-function-cast -Wcast-align \
@@ -102,16 +106,16 @@
 
 install-bin:
 		-${MKDIR} ${DESTDIR}${BINDIR}
-		install -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} ${PROG} ${DESTDIR}${BINDIR}/
+		${INSTALL_PROGRAM} ${PROG} ${DESTDIR}${BINDIR}/
 
 install-man:
 		-${MKDIR} ${DESTDIR}${MANDIR}1
-		install -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} ${MAN1GZ} ${DESTDIR}${MANDIR}1/
+		${INSTALL_DATA} ${MAN1GZ} ${DESTDIR}${MANDIR}1/
 
 install-examples:
 		-${MKDIR} ${DESTDIR}${EXAMPLESDIR}/tests
-		install -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} t/*.t ${DESTDIR}${EXAMPLESDIR}/tests/
-		install -c -o ${SHAREOWN} -g ${SHAREGRP} -m ${SHAREMODE} t/*.ini ${DESTDIR}${EXAMPLESDIR}/tests/
+		${INSTALL_SCRIPT} t/*.t ${DESTDIR}${EXAMPLESDIR}/tests/
+		${INSTALL_DATA} t/*.ini ${DESTDIR}${EXAMPLESDIR}/tests/
 
 depend:
 		touch readaline.h

=== debian/changelog ===
confget (2.2.0-4+deb10u1) buster; urgency=medium

  * Fix the Python module's handling of values containing "=":
    - add the test-ini-eq patch to add a test for such values
    - add the python-value-eq patch to fix the problem
    - Closes: #959887

 -- Peter Pentchev <roam@debian.org>  Wed, 06 May 2020 19:12:09 +0300

confget (2.2.0-4) unstable; urgency=medium

  * Use the test-name autopkgtest feature.

 -- Peter Pentchev <roam@debian.org>  Wed, 27 Feb 2019 00:44:26 +0200

confget (2.2.0-3) unstable; urgency=medium

  * Switch to a DEP-14 debian/master branch.

 -- Peter Pentchev <roam@debian.org>  Thu, 14 Feb 2019 18:04:50 +0200

confget (2.2.0-2) unstable; urgency=medium

  * Move the Python build dependencies to Build-Depends-Indep and
    only use the Python buildsystem when available, thus allowing
    confget to actually build on architectures where PyPy is not
    available yet.

 -- Peter Pentchev <roam@debian.org>  Tue, 15 Jan 2019 14:45:18 +0200

confget (2.2.0-1) unstable; urgency=medium

  * New upstream version:
    - update the upstream copyright years
    - build the Python 2.x, 3.x, and PyPy modules
    - run the TAP tests (both at build time and via autopkgtest) with
      the Python modules, too, not only with the C executable
  * Add the year 2019 to my debian/* copyright notice.
  * Declare compliance with Debian Policy 4.3.0 with no changes.
  * Bump the debhelper compatibility level to 12 with no changes.
  * Add a trivial git-buildpackage config file.
  * Conditionally run some commands in the rules file depending on which
    packages are being built.
  * Change DEB_NODOC to BUILD_DOC for consistency.
  * Check for "nocheck" in DEB_BUILD_OPTIONS before running tests.
  * Break out the autopkgtests's "is the documentation installed" check
    into a separate tool.
  * Run `dh_missing --fail-missing`.

 -- Peter Pentchev <roam@debian.org>  Mon, 14 Jan 2019 12:38:52 +0200

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 # Debian build rules for confget, the configuration variable extractor
+
+export PYBUILD_NAME=confget
+export PYBUILD_DISABLE=test/pypy
 
 # Aim for the top, adapt if anything should break on the buildds.
 DEB_BUILD_MAINT_OPTIONS=	hardening=+all future=+lfs
@@ -18,17 +21,55 @@
 export PCRE_CPPFLAGS=-DHAVE_PCRE
 export PCRE_LIBS=-lpcre
 
-ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
-DEB_NODOC=0
+ifneq (,$(filter confget,$(shell dh_listpackages)))
+BUILD_IMPL_C=yes
 else
-DEB_NODOC=1
+BUILD_IMPL_C=no
+endif
+ifneq (,$(filter pypy-confget,$(shell dh_listpackages)))
+BUILD_IMPL_PYPY=yes
+else
+BUILD_IMPL_PYPY=no
+endif
+ifneq (,$(filter python-confget,$(shell dh_listpackages)))
+BUILD_IMPL_PY2=yes
+else
+BUILD_IMPL_PY2=no
+endif
+ifneq (,$(filter python3-confget,$(shell dh_listpackages)))
+BUILD_IMPL_PY3=yes
+else
+BUILD_IMPL_PY3=no
+endif
+ifneq (no no no,${BUILD_IMPL_PYPY} ${BUILD_IMPL_PY2} ${BUILD_IMPL_PY3})
+BUILD_IMPL_PY=yes
+else
+BUILD_IMPL_PY=no
 endif
 
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
+BUILD_DOC=yes
+else
+BUILD_DOC=no
+endif
+
+D=	${CURDIR}/debian
+DTMP=	$D/tmp
+PY=	${CURDIR}/python
+TESTD=	${CURDIR}/t
+
 override_dh_auto_build:
+	@echo 'building C: ${BUILD_IMPL_C}, py2: ${BUILD_IMPL_PY2}, py3: ${BUILD_IMPL_PY3}, python: ${BUILD_IMPL_PY}, doc: ${BUILD_DOC}'
+ifeq (yes,${BUILD_IMPL_C})
 	dh_auto_build -- LFS_CPPFLAGS= LFS_LDFLAGS=
+endif
+ifeq (yes,${BUILD_IMPL_PY})
+	dh_auto_build -D '${PY}' --buildsystem pybuild
+endif
 
 override_dh_auto_install:
-ifeq (${DEB_NODOC},1)
+ifeq (yes,${BUILD_IMPL_C})
+ifeq (no,${BUILD_DOC})
 	mv -f Makefile Makefile.bak
 	sed -e 's/^install:.*/install: all install-bin/' Makefile.bak > Makefile
 endif
@@ -37,13 +78,49 @@
 		EXAMPLESDIR=/usr/share/doc/confget/examples \
 		INSTALL_PROGRAM='install -m 755' \
 		INSTALL_SCRIPT='install -m 755' INSTALL_DATA='install -m 644'
-ifeq (${DEB_NODOC},1)
+ifeq (no,${BUILD_DOC})
 	mv -f Makefile.bak Makefile
+endif
+endif
+ifeq (yes,${BUILD_IMPL_PY})
+	dh_auto_install -D '${PY}' --buildsystem pybuild
+endif
+
+ifeq (,$(filter nocheck,${DEB_BUILD_OPTIONS}))
+override_dh_auto_test:
+ifeq (yes,${BUILD_IMPL_C})
+	dh_auto_test
+endif
+ifeq (yes,${BUILD_IMPL_PY})
+	env PYTHONPATH='${PY}' '$D/tests/tap-python.sh'
+	env TESTDIR='${TESTD}' dh_auto_test -D '${PY}' --buildsystem pybuild -- --test-pytest --test-args '${PY}/unit_tests'
+endif
 endif
 
 override_dh_installchangelogs:
 	dh_installchangelogs -X CHANGES
-	install -m 644 CHANGES debian/confget/usr/share/doc/confget/NEWS
+	set -e; for pkg in $$(dh_listpackages); do \
+		install -m 644 CHANGES "debian/$$pkg/usr/share/doc/$$pkg/NEWS"; \
+	done
+
+override_dh_auto_clean:
+	dh_auto_clean
+	if dpkg-query -W -f '$${Package}\n' | fgrep -qxe python-setuptools -e python3-setuptools -e pypy-setuptools; then \
+		dh_auto_clean -D '${PY}' --buildsystem pybuild; \
+	fi
+	rm -rf -- '${PY}/.pytest_cache' '${PY}/confget.egg-info'
+
+override_dh_missing:
+	dh_missing --fail-missing
 
 %:
-	dh $@
+	set -e; \
+	unset with; \
+	for pkg in python2 python3 pypy; do \
+		if dpkg-query -W "$${pkg%2}-setuptools" > /dev/null 2>&1; then \
+			with="$$with,$$pkg"; \
+		fi; \
+	done; \
+	with="$${with:+--with $${with#,}}"; \
+	echo "Running 'dh $@ $$with'"; \
+	dh $@ $$with

=== debian/tests/control ===
Test-Command: debian/tests/check-doc.sh env CONFGET='/usr/bin/confget' sh -c 'exec prove -v "$TESTDIR"'
Depends: @, perl, groff-base
Features: test-name=tap-perl

Test-Command: debian/tests/check-doc.sh debian/tests/tap-python.sh
Depends: @, perl, groff-base
Features: test-name=tap-python

Test-Command: adequate confget
Depends: @, adequate
Features: test-name=adequate

Test-Command: feature-check -O -qfeatures -P '' confget BASE
Depends: @, feature-check
Features: test-name=feature-check

## confget 2.3.0

=== debian/changelog ===
confget (2.3.0-1) unstable; urgency=medium

  * New upstream version:
    - drop the test-too-many-pypy patch, integrated upstream
    - refresh the python-no-executable patch
  * Declare compliance with Debian Policy 4.4.0 with no changes.
  * Drop the PyPy package.
  * Drop the Python 2.x package, too.  Closes: #936324
  * Mark the adequate and feature-check tests as superficial.

 -- Peter Pentchev <roam@debian.org>  Mon, 09 Sep 2019 16:15:03 +0300

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,20 @@
 Section: text
 Priority: optional
 Maintainer: Peter Pentchev <roam@debian.org>
-Build-Depends: debhelper-compat (= 11), libpcre3-dev
-Standards-Version: 4.2.1
+Build-Depends:
+ debhelper-compat (= 12),
+ dh-python,
+ libpcre3-dev,
+Build-Depends-Indep:
+ python3-all,
+ python3-ddt,
+ python3-pytest,
+ python3-six,
+ python3-setuptools,
+Standards-Version: 4.4.0
 Homepage: https://devel.ringlet.net/textproc/confget/
-Vcs-Git: https://gitlab.com/confget/confget.git -b debian
-Vcs-Browser: https://gitlab.com/confget/confget/tree/debian
+Vcs-Git: https://gitlab.com/confget/confget.git -b debian/master
+Vcs-Browser: https://gitlab.com/confget/confget/tree/debian/master
 Rules-Requires-Root: no
 
 Package: confget
@@ -25,3 +34,26 @@
  check if a variable is present in the file at all.  It has a "shell-quoting"
  output mode that quotes the variable values in a way suitable for passing
  them directly to a Bourne-style shell.
+
+Package: python3-confget
+Section: python
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}, ${python3:Depends}
+Recommends: ${python3:Recommends}
+Suggests: ${python3:Suggests}
+Provides: ${python3:Provides}
+Description: read variables from INI-style configuration files - Python 3.x library
+ The confget utility examines a INI-style configuration file and retrieves
+ the value of the specified variables from the specified section.
+ Its intended use is to let shell scripts use the same INI-style
+ configuration files as other programs, to avoid duplication of data.
+ .
+ The confget utility may retrieve the values of one or more variables,
+ list all the variables in a specified section, list only those whose names
+ or values match a specified pattern (shell glob or regular expression), or
+ check if a variable is present in the file at all.  It has a "shell-quoting"
+ output mode that quotes the variable values in a way suitable for passing
+ them directly to a Bourne-style shell.
+ .
+ This package contains the Python 3.x library.

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,6 @@
 # Debian build rules for confget, the configuration variable extractor
 
 export PYBUILD_NAME=confget
-export PYBUILD_DISABLE=test/pypy
 
 # Aim for the top, adapt if anything should break on the buildds.
 DEB_BUILD_MAINT_OPTIONS=	hardening=+all future=+lfs
@@ -26,22 +25,7 @@
 else
 BUILD_IMPL_C=no
 endif
-ifneq (,$(filter pypy-confget,$(shell dh_listpackages)))
-BUILD_IMPL_PYPY=yes
-else
-BUILD_IMPL_PYPY=no
-endif
-ifneq (,$(filter python-confget,$(shell dh_listpackages)))
-BUILD_IMPL_PY2=yes
-else
-BUILD_IMPL_PY2=no
-endif
 ifneq (,$(filter python3-confget,$(shell dh_listpackages)))
-BUILD_IMPL_PY3=yes
-else
-BUILD_IMPL_PY3=no
-endif
-ifneq (no no no,${BUILD_IMPL_PYPY} ${BUILD_IMPL_PY2} ${BUILD_IMPL_PY3})
 BUILD_IMPL_PY=yes
 else
 BUILD_IMPL_PY=no
@@ -59,7 +43,7 @@
 TESTD=	${CURDIR}/t
 
 override_dh_auto_build:
-	@echo 'building C: ${BUILD_IMPL_C}, py2: ${BUILD_IMPL_PY2}, py3: ${BUILD_IMPL_PY3}, python: ${BUILD_IMPL_PY}, doc: ${BUILD_DOC}'
+	@echo 'building C: ${BUILD_IMPL_C}, python: ${BUILD_IMPL_PY}, doc: ${BUILD_DOC}'
 ifeq (yes,${BUILD_IMPL_C})
 	dh_auto_build -- LFS_CPPFLAGS= LFS_LDFLAGS=
 endif
@@ -105,7 +89,7 @@
 
 override_dh_auto_clean:
 	dh_auto_clean
-	if dpkg-query -W -f '$${Package}\n' | fgrep -qxe python-setuptools -e python3-setuptools -e pypy-setuptools; then \
+	if dpkg-query -W -f '$${Package}\n' | fgrep -qxe python3-setuptools; then \
 		dh_auto_clean -D '${PY}' --buildsystem pybuild; \
 	fi
 	rm -rf -- '${PY}/.pytest_cache' '${PY}/confget.egg-info'
@@ -115,12 +99,10 @@
 
 %:
 	set -e; \
-	unset with; \
-	for pkg in python2 python3 pypy; do \
-		if dpkg-query -W "$${pkg%2}-setuptools" > /dev/null 2>&1; then \
-			with="$$with,$$pkg"; \
-		fi; \
-	done; \
-	with="$${with:+--with $${with#,}}"; \
+	if dpkg-query -W python3-setuptools > /dev/null 2>&1; then \
+		with='--with python3'; \
+	else \
+		with=''; \
+	fi; \
 	echo "Running 'dh $@ $$with'"; \
 	dh $@ $$with

=== debian/tests/control ===
--- 
+++ 
@@ -9,7 +9,9 @@
 Test-Command: adequate confget
 Depends: @, adequate
 Features: test-name=adequate
+Restrictions: superficial
 
 Test-Command: feature-check -O -qfeatures -P '' confget BASE
 Depends: @, feature-check
 Features: test-name=feature-check
+Restrictions: superficial

## confget 2.3.3

=== debian/changelog ===
confget (2.3.3-1) unstable; urgency=medium

  * Temporarily disable the adequate test.
  * New upstream release:
    - refresh the python-no-executable patch
  * Simplify the rules file inspired by some suggestions from Niels Thykier:
    - use debian/clean to remove the Python directories
    - configure pybuild and pytest through the environment
    - separate the -arch and -indep builds
    - add the no-doc-build patch to simplify the build
  * Drop the no-dh-sequencer override, it was only there to silence
    a Lintian false positive that was fixed in Lintian 2.51.0.

 -- Peter Pentchev <roam@debian.org>  Tue, 07 Apr 2020 17:43:38 +0300

confget (2.3.1-1) unstable; urgency=medium

  * New upstream release.
  * Depend on debhelper >> 12.8~ for execute_after.

 -- Peter Pentchev <roam@debian.org>  Wed, 01 Apr 2020 12:10:20 +0300

confget (2.3.0-2) unstable; urgency=medium

  * Mark test-only build dependencies with <!nocheck>.
  * Declare compliance with Policy 4.5.0 with no changes.
  * Override the "no dh sequencer" Lintian info tag.
  * autopkgtest: supported, not installed, Python versions.
  * Add the year 2020 to my debian/* copyright notice.
  * Bump the debhelper compatibility level to 13:
    - reintroduce the debian/compat file while compat level 13 is
      still in beta
    - drop the conditional around the "auto_test" target - debhelper
      will not execute it at all unless it is needed
    - use "execute_after" for the "auto_clean" target
    - drop the "dh_missing" override; "--fail-missing" is the default now

 -- Peter Pentchev <roam@debian.org>  Fri, 20 Mar 2020 01:45:56 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,17 @@
 Priority: optional
 Maintainer: Peter Pentchev <roam@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper (>> 12.8~),
  dh-python,
  libpcre3-dev,
 Build-Depends-Indep:
+ dh-sequence-python3,
  python3-all,
- python3-ddt,
- python3-pytest,
- python3-six,
+ python3-ddt <!nocheck>,
+ python3-pytest <!nocheck>,
+ python3-six <!nocheck>,
  python3-setuptools,
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Homepage: https://devel.ringlet.net/textproc/confget/
 Vcs-Git: https://gitlab.com/confget/confget.git -b debian/master
 Vcs-Browser: https://gitlab.com/confget/confget/tree/debian/master

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Debian build rules for confget, the configuration variable extractor

# Aim for the top, adapt if anything should break on the buildds.
DEB_BUILD_MAINT_OPTIONS=	hardening=+all future=+lfs
export DEB_BUILD_MAINT_OPTIONS

DEB_CFLAGS_MAINT_APPEND=	-pipe -Wall -W -std=c99 -pedantic -Wbad-function-cast \
		-Wcast-align -Wcast-qual -Wchar-subscripts -Winline \
		-Wmissing-prototypes -Wnested-externs -Wpointer-arith \
		-Wredundant-decls -Wshadow -Wstrict-prototypes -Wwrite-strings
ifneq (,$(filter werror,$(DEB_BUILD_OPTIONS)))
	DEB_CFLAGS_MAINT_APPEND+=	-Werror
endif
export DEB_CFLAGS_MAINT_APPEND

export PCRE_CPPFLAGS=-DHAVE_PCRE
export PCRE_LIBS=-lpcre

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
NO_DOC_BUILD=
else
export NO_DOC_BUILD=1
endif

D=	${CURDIR}/debian
DTMP=	$D/tmp
PY=	${CURDIR}/python

export TESTDIR=${CURDIR}/t

export PYBUILD_NAME=confget
export PYBUILD_DIR=${PY}
export PYBUILD_TEST_PYTEST=1

# OK, so this is not the best way to set this, but oh well
export PYTEST_ADDOPTS=${PY}/unit_tests

override_dh_auto_build-arch:
	dh_auto_build -- LFS_CPPFLAGS= LFS_LDFLAGS=

override_dh_auto_build-indep:
	dh_auto_build --buildsystem pybuild

override_dh_auto_install-arch:
	dh_auto_install -- DESTDIR=${CURDIR}/debian/confget PREFIX=/usr \
		MANDIR=/usr/share/man/man BINGRP=root MANGRP=root \
		EXAMPLESDIR=/usr/share/doc/confget/examples \
		INSTALL_PROGRAM='install -m 755' \
		INSTALL_SCRIPT='install -m 755' INSTALL_DATA='install -m 644'

override_dh_auto_install-indep:
	dh_auto_install --buildsystem pybuild

override_dh_auto_test-indep:
	env PYTHONPATH='${PY}' '$D/tests/tap-python.sh'
	dh_auto_test --buildsystem pybuild

override_dh_installchangelogs:
	dh_installchangelogs -X CHANGES
	set -e; for pkg in $$(dh_listpackages); do \
		install -m 644 CHANGES "debian/$$pkg/usr/share/doc/$$pkg/NEWS"; \
	done

execute_after_dh_auto_clean-indep:
	if dpkg-query -W -f '$${Package}\n' | fgrep -qxe python3-setuptools; then \
		dh_auto_clean --buildsystem pybuild; \
	fi

%:
	dh '$@'

## confget 2.3.4

=== Makefile ===
--- 
+++ 
@@ -86,7 +86,8 @@
 
 TESTEXEC=	test-getline test-fgetln
 
-all:		${PROG} ${MAN1GZ}
+all:		${PROG}
+		[ -n '${NO_DOC_BUILD}' ] || ${MAKE} ${MAN1GZ}
 
 clean:
 		${RM} ${PROG} ${OBJS} ${MAN1GZ}
@@ -102,7 +103,8 @@
 		gzip -c9 ${MAN1} > ${MAN1GZ}.tmp
 		mv ${MAN1GZ}.tmp ${MAN1GZ}
 
-install:	all install-bin install-man install-examples
+install:	all install-bin
+		[ -n '${NO_DOC_BUILD}' ] || ${MAKE} install-man install-examples
 
 install-bin:
 		-${MKDIR} ${DESTDIR}${BINDIR}

=== debian/changelog ===
confget (2.3.4-1) unstable; urgency=medium

  * Go back to the B-D: debhelper-compat way now that dh 13 is out.
  * Correct the upstream copyright years (add the year 2020).
  * Drop the Name and Contact upstream metadata fields.
  * New upstream release:
    - refresh the python-no-executable patch
    - adapt the test target to the moved confget Python source

 -- Peter Pentchev <roam@debian.org>  Sat, 02 May 2020 22:30:35 +0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Peter Pentchev <roam@debian.org>
 Build-Depends:
- debhelper (>> 12.8~),
+ debhelper-compat (= 13),
  dh-python,
  libpcre3-dev,
 Build-Depends-Indep:

=== debian/rules ===
--- 
+++ 
@@ -54,7 +54,7 @@
 	dh_auto_install --buildsystem pybuild
 
 override_dh_auto_test-indep:
-	env PYTHONPATH='${PY}' '$D/tests/tap-python.sh'
+	env PYTHONPATH='${PY}/src' '$D/tests/tap-python.sh'
 	dh_auto_test --buildsystem pybuild
 
 override_dh_installchangelogs:
